import { createAsyncThunk } from "@reduxjs/toolkit";
import axios from "axios";
import { LOADING_END, LOADING_START } from "../../../lib/redux/slices/appSlice";
import { getRoleFromUrl } from "../../../utils/getRoleFromUrl";

/*
  props {
    search = "filter",
    value = "",
    page = 1,
    page_size = 10,
    steward = false,
    active_state = "active",
    is_real_person = true,
    role_key = "",
  }
*/
export const provinceGetTotalGuildsService = createAsyncThunk(
  "PROVINCE_GET_TOTAL_GUILDS_SERVICE",
  async (d, { dispatch }) => {
    try {
      dispatch(LOADING_START());
      const { data, status } = await axios.get("total_guilds/", {
        params: {
          ...d,
          role: getRoleFromUrl(),
        },
      });
      dispatch(LOADING_END());
      return { data, status };
    } catch (e) {
      dispatch(LOADING_END());
      return {
        error:
          e.response?.data?.result ||
          e.response?.data ||
          "خطا در دریافت اطلاعات",
      };
    }
  }
);
